#!/usr/bin/perl

sub dodir
{
    my($f);
    my($fn);
    my(@files);
    my($dir)= shift;

    opendir(Z,$dir);
	@files= readdir(Z);
    closedir(Z);

    foreach $f (@files)
    {
	next if($f eq ".");
	next if($f eq "..");

	$fn= "$dir/$f";
	if(-d $fn)
	{
	    dodir($fn) if(-d $fn);
	}
	else
	{
	    if(
		($fn=~ /\.pnm$/)	||
		($f eq Track)
	    )
	    {
		chmod 0666, $fn || die "couldn't chmod $fn\n$!\n";
	    }
	    else
	    {
		$fn=~s/^\.\///;
		my($nfn) = "$fn.m$$";
		open(OF,"<$fn")   || die "couldn't open $fn\n$!\n";
		open(NF,">$nfn") || die "couldn't open $nfn\n$!\n";
		while(<OF>)
		{
		    s/\015//;
		    print NF $_;
		}
		close(OF);
		close(NF);

		print "$fn\n";
		($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($fn);
		utime($atime,$mtime,$nfn);
		if($fn =~ /(\.pl)$/ || $fn =~ /(\.sh)/)
		{
		    chmod 0777, $fn || die "couldn't chmod $fn\n$!\n";
		    chmod 0777, $nfn || die "couldn't chmod $nfn\n$!\n";
		}
		else
		{
		    chmod 0666, $fn || die "couldn't chmod $fn\n$!\n";
		    chmod 0666, $nfn || die "couldn't chmod $nfn\n$!\n";
		}
		rename($nfn,$fn) || die "couldn't rename $nfn to $fn\n$!\n";
	    }
	}
    }
}

($#ARGV >= 0) || die "usage: $0 <dir>\n";
dodir($ARGV[0]);

